<!--
@license
Copyright (c) 2018 Pierre-Yves Gicquel. 
This code may only be used under the "Do whatever you want with code license"
-->
<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../paper-toggle-button/paper-toggle-button.html">
<link rel="import" href="../iron-collapse/iron-collapse.html">
<link rel="import" href="../common-styles/common-styles.html">
<link rel="import" href="../activity-feedback/activity-feedback.html">
<link rel="import" href="../staticmedia-viewer/staticmedia-viewer.html">

<!--
`free-text-question`
Une question pour la suelle la réponse est libre (champ texte).
Il est possible d'associer un indice à la question sous forme d'un static-media
L'utilisateur est informé de son résultat via les paramètres correctMessage et wrongMessage
@demo demo/index.html
-->

<dom-module id="free-text-question">
    <style include="common-styles">
        .question {
            margin-top: 10px;
            padding: 8px;
            @apply(--paper-font-body2);
        }

        .response {
            width: 100%;
        }

        .validator {
            margin-top: 30px;
        }
    </style>
    <template>
        <div class="resource">
            <div class="question">{{question}}</div>
            <div class="resourceBody">
                <paper-input name="response" class="response" value="{{userResponse}}"  label="{{responseLabel}}"></paper-input>
                <template is="dom-if" if="[[media]]" restamp=true>
                    <paper-toggle-button checked={{showClue}}>Indice</paper-toggle-button>
                </template>
                <iron-collapse opened=[[showClue]] id="clue">
                    <staticmedia-viewer mkdown=[[media.mkdown]]></staticmedia-viewer>
                </iron-collapse>
                <activity-feedback id="feedback" response-status=[[responseStatus]] correct-message=[[correctMessage]] wrong-message=[[wrongMessage]]></activity-feedback>
                <paper-icon-button class="validator" src="check.png" on-click="validate"></paper-icon-button>
            </div>
        </div>
    </template>
    <script>
        (function () {
            'use strict';
            Polymer({
                is: 'free-text-question',
                hideMessages:function(){
                    this.responseStatus=""
                }
                ,
                validate: function () {
                    if (this.response === this.userResponse) {
                        this.responseStatus="correct"
                    } else {
                        this.responseStatus="wrong"
                    }
                },
                properties: {
                    /*
                    * This property inform if the question has been answered (click on check)
                    * and if the response is "correct" or "wrong"
                    */
                    responseStatus:{
                        type: String,
                        notify : true,
                        value:'',
                        reflectToAttribute : true,
                    },
                    /*
                    The question to ask
                    */
                    question: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',
                    },
                    /*
                    The correct response
                    */
                    response: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',

                    },
                    /*
                    Message to show if the correct response is given
                    */
                    correctMessage: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',
                    },
                    /*
                    Message to show if the response isn't correct
                    */
                    wrongMessage: {
                        type: String,
                        notify: true,
                        observer : '_resetQuestion',
                    },
                    media: {
                        type: Object,
                        notify: true,
                        observer : '_resetQuestion',
                    },

                },
                _resetQuestion:function(){
                    this.responseStatus=''
                    this.userResponse=''
                },

            });
        })();
    </script>
</dom-module>